<?php
/*======================================================================*\
|| #################################################################### ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2007-2009 Fillip Hannisdal AKA Revan/NeoRevan/Belazor # ||
|| # All Rights Reserved. 											  # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| # You are not allowed to use this on your server unless the files  # ||
|| # you downloaded were done so with permission.					  # ||
|| # ---------------------------------------------------------------- # ||
|| #################################################################### ||
\*======================================================================*/

// #############################################################################
if ($_REQUEST['action'] == 'forum' OR empty($_REQUEST['action']))
{
	$forumids = array();
	foreach ((array)$vbulletin->forumcache as $forumid => $forum)
	{
		if (!THANKS::$is_pro AND $forum['parentid'] != -1)
		{
			// This forum isn't a parent forum
			continue;
		}
		
		$forumids[] = $forumid;
	}
	
	
	$headings = array();
	$headings[] = $vbphrase['forum'];
	foreach (THANKS::$cache['button'] as $buttonid => $button)
	{
		// Show button headers
		$headings[] = $button['title'];
	}
	
	print_cp_header(strip_tags(construct_phrase($vbphrase['dbtech_thanks_editing_x_y'], $vbphrase['permissions'], $vbphrase['forum'])));
	print_form_header('thanks', 'forum');
	construct_hidden_code('action', 'updateforum');	
	print_table_header(construct_phrase($vbphrase['dbtech_thanks_editing_x_y'], $vbphrase['permissions'], $vbphrase['forum']), count($headings));
	print_cells_row($headings, 0, 'thead');
	
	foreach ((array)$forumids as $forumid)
	{
		// Shorthand
		$forum = $vbulletin->forumcache["$forumid"];
		$cell = array();
		$cell[] = construct_depth_mark($forum['depth'],'- - ') . $forum['title'];
		foreach (THANKS::$cache['button'] as $buttonid => $button)
		{
			$cell[] = '
				<center>
					<input type="hidden" name="forum[' . $forumid . '][' . $buttonid . ']" value="0" />
					<label for="cb_forum_' . $forumid . '_' . $button['varname'] . '">
						<input type="checkbox" name="forum[' . $forumid . '][' . $buttonid . ']" id="cb_forum_' . $forumid . '_' . $button['varname'] . '" value="1"' . (!((int)$forum['dbtech_thanks_disabledbuttons'] & (int)$button['bitfield']) ? ' checked="checked"' : '') . ($vbulletin->debug ? ' title="name=&quot;forum[' . $forumid . '][' . $button['varname'] . ']&quot;"' : '') . '/>
						' . $button['title'] . '
					</label>
				</center>
			';
		}
		print_cells_row($cell, 0, 0, -5, 'middle', 0, 1);	
	}
	print_submit_row($vbphrase['save'], false, count($headings));
	print_cp_footer();
}

// #############################################################################
if ($_POST['action'] == 'updateforum')
{
	// Grab stuff
	$vbulletin->input->clean_array_gpc('p', array(
		'forum' 	=> TYPE_ARRAY,
	));
	
	foreach ($vbulletin->GPC['forum'] as $forumid => $buttons)
	{
		$disabled = 0;	
		foreach ($buttons as $buttonid => $yesno)
		{
			if ($yesno)
			{
				// Enabled
				continue;
			}
			
			// Add this to the enabled bits
			$disabled += THANKS::$cache['button']["$buttonid"]['bitfield'];
		}
		
		if ($disabled != $vbulletin->forumcache["$forumid"]['dbtech_thanks_disabledbuttons'])
		{
			// Will never return false but meh
			$db->query_write("
				UPDATE " . TABLE_PREFIX . "forum
				SET dbtech_thanks_disabledbuttons = $disabled
				WHERE forumid = " . $db->sql_prepare($forumid)
			);
		}
	}
	
	require_once(DIR . '/includes/adminfunctions_forums.php');
	build_forum_permissions();
	
	define('CP_REDIRECT', 'thanks.php?do=forum');
	print_stop_message('dbtech_thanks_x_y', $vbphrase['permissions'], $vbphrase['dbtech_thanks_edited']);	
}

/*=======================================================================*\
|| ##################################################################### ||
|| # Created: 17:29, Sat Dec 27th 2008                                 # ||
|| # SVN: $RCSfile: instance.php,v $ - $Revision: $WCREV$ $
|| ##################################################################### ||
\*=======================================================================*/
?>