<?php
/*======================================================================*\
|| #################################################################### ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright ©2007-2009 Fillip Hannisdal AKA Revan/NeoRevan/Belazor # ||
|| # All Rights Reserved. 											  # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| # You are not allowed to use this on your server unless the files  # ||
|| # you downloaded were done so with permission.					  # ||
|| # ---------------------------------------------------------------- # ||
|| #################################################################### ||
\*======================================================================*/

// Add to the navbits
$navbits[''] = $pagetitle = $vbphrase['dbtech_thanks_statistics'];

// draw cp nav bar
THANKS::construct_nav('statistics');

// Set the limit on number of users to fetch
$limit = (isset($vbulletin->options['dbtech_thanks_statistics_topx']) ? $vbulletin->options['dbtech_thanks_statistics_topx'] : 5);

$types = array();
$types2 = array();

foreach (THANKS::$cache['button'] as $button)
{
	if (!$button['active'])
	{
		// Inactive button
		continue;
	}
	
	$types[] = $button['varname'] . '_given';
	$types[] = $button['varname'] . '_received';
	
	$types2[$button['varname'] . '_given'] = $button['title'] . ' (' . $vbphrase['dbtech_thanks_given'] . ')';
	$types2[$button['varname'] . '_received'] = $button['title'] . ' (' . $vbphrase['dbtech_thanks_received'] . ')';
}

// Init this array
$leaders = array();

// Init these
$leaderboardbits = '';

foreach ($types as $type)
{
	// Init this
	$userbits = array();
	$xmlbits = array();
	
	// Fetch rewards
	$leaders_q = $db->query_read_slave("
		SELECT
			{$type} AS value,
			user.userid,
			username,
			user.usergroupid,
			infractiongroupid,
			displaygroupid
			" . ($vbulletin->products['dbtech_vbshop'] ? ", dbtech_vbshop_purchase" : '') . "
		FROM " . TABLE_PREFIX . "dbtech_thanks_statistics AS dbtech_thanks_statistics
		LEFT JOIN " . TABLE_PREFIX . "user AS user USING(userid)
		LEFT JOIN " . TABLE_PREFIX . "usergroup AS usergroup ON (usergroup.usergroupid = user.usergroupid)
		WHERE (usergroup.genericoptions & " . $vbulletin->bf_ugp_genericoptions['isnotbannedgroup'] . ")
		GROUP BY user.userid
		ORDER BY value DESC, username ASC
		LIMIT $limit
	");
	
	$key = 0;
	while ($userinfo = $db->fetch_array($leaders_q))
	{
		// Grab the musername
		fetch_musername($userinfo);
		
		if ($userinfo['value'] == 0)
		{
			// We don't want to count empty users
			continue;
		}
		
		if (intval($vbulletin->versionnumber) == 3)
		{
			$link = "member.php?" . $vbulletin->session->vars['sessionurl'] . "u=$userinfo[userid]";				
		}
		else
		{
			$link = fetch_seo_url('member', $userinfo);
		}
		$userinfo['musername'] = '<a href="' . $link . '" target="_blank">' . $userinfo['musername'] . '</a>';
		
		$j = ++$key;
		$templater = vB_Template::create('dbtech_thanks_statistics_userbit');
			$templater->register('userinfo', $userinfo);
		$userbits["$j"] .= $templater->render();

		if ($_REQUEST['xml'])
		{
			$xmlbits[] = array($userinfo['username'], $link, $userinfo['value']);
		}
	}
	$db->free_result($leaders_q);
	unset($leaders_r);		
	
	for ($k = 1; $k <= $limit; $k++)
	{
		if (!$userbits["$k"])
		{
			// Didn't have this point
			$userbits["$k"] = vB_Template::create('dbtech_thanks_statistics_userbit')->render();
		}
	}
	
	// Make sure we also got the phrase
	$phrase = construct_phrase($vbphrase['dbtech_thanks_top_x'], $limit, $types2["$type"]);
	
	if ($_REQUEST['xml'])
	{
		$this->xml[] = array(
			'phrase'	=> $phrase,
			'bits'		=> $xmlbits,
		);
	}
	
	$templater = vB_Template::create('dbtech_thanks_statistics_statisticbit');
		$templater->register('phrase', $phrase);
		$templater->register('userbits', implode('', $userbits));
	$leaderboardbits .= $templater->render();
}

// Begin the page template
$page_templater = vB_Template::create('dbtech_thanks_statistics');
	$page_templater->register('pagetitle', $pagetitle);
	$page_templater->register('leaderboardbits', $leaderboardbits);
$HTML = $page_templater->render();

/*=======================================================================*\
|| ##################################################################### ||
|| # Created: 17:29, Sat Dec 27th 2008                                 # ||
|| # SVN: $RCSfile: button.php,v $ - $Revision: $WCREV$ $
|| ##################################################################### ||
\*=======================================================================*/
?>