<?php
if (!isset(THANKS::$entrycache))
{
	// Init this
	THANKS::$entrycache = array();
	
	// Fetch rewards
	$results_q = $db->query_read_slave("
		SELECT
			entry.contentid,
			entry.varname,
			entry.dateline,
			user.userid,
			user.username,
			user.usergroupid,
			user.infractiongroupid,
			user.displaygroupid
		FROM " . TABLE_PREFIX . "dbtech_thanks_entry AS entry
		LEFT JOIN " . TABLE_PREFIX . "post AS post ON(post.postid = entry.contentid)
		LEFT JOIN " . TABLE_PREFIX . "user AS user ON(user.userid = entry.userid)
		WHERE post.visible = 1
			$globalignore
			AND post.threadid = $threadinfo[threadid]
			AND entry.contenttype = 'post'
		ORDER BY entry.contentid ASC, entry.dateline DESC
	");
	while ($results_r = $db->fetch_array($results_q))
	{
		THANKS::$entrycache["$results_r[contentid]"]["$results_r[varname]"]['data'][] = $results_r;
	}
	$db->free_result($results_q);
	unset($results_r);
}

$override = array();
if ($post['dbtech_thanks_requiredbuttons_content'])
{
	foreach (THANKS::$cache['button'] as $button)
	{
		if (!$button['active'])
		{
			// Inactive button
			continue;
		}
		
		if (!$button['active'])
		{
			// Inactive button
			continue;
		}
		
		if (((int)$post['dbtech_thanks_requiredbuttons_content'] & (int)$button['bitfield']) AND 
			$post['userid'] != $vbulletin->userinfo['userid'] AND 
			!THANKS::$entrycache["{$post[postid]}"]["$button[varname]"]['data']["{$vbulletin->userinfo[userid]}"]
		)
		{
			// Override message on the attach field
			$override[] = $vbphrase['dbtech_thanks_stripped_content'];
		}
	}
}

// Ensure this works as intended
$override = implode('<br />', $override);		

if (!THANKS::$is_pro)
{					
	if ($override)
	{
		// We require something
		$reviewmessage = $override;
	}
}
else
{
	// We may or may not require something
	THANKS::parse_bbcode($reviewmessage, ($override ? $override : '$1'));
}