<?php
/*======================================================================*\
|| #################################################################### ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright ©2007-2009 Fillip Hannisdal AKA Revan/NeoRevan/Belazor # ||
|| # All Rights Reserved. 											  # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| # You are not allowed to use this on your server unless the files  # ||
|| # you downloaded were done so with permission.					  # ||
|| # ---------------------------------------------------------------- # ||
|| #################################################################### ||
\*======================================================================*/

// #############################################################################
if ($_REQUEST['action'] == 'maintenance' OR empty($_REQUEST['action']))
{
	print_cp_header($vbphrase['maintenance']);
	
	print_form_header('thanks', 'maintenance');
	construct_hidden_code('action', 'cleanup');
	print_table_header($vbphrase['dbtech_thanks_cleanup'], 2, 0);
	print_description_row($vbphrase['dbtech_thanks_cleanup_descr']);
	print_input_row($vbphrase['number_of_posts_to_process_per_cycle'], 'perpage', 1000);
	print_submit_row($vbphrase['dbtech_thanks_cleanup']);
	
	print_form_header('thanks', 'maintenance');
	construct_hidden_code('action', 'recalc');	
	print_table_header($vbphrase['dbtech_thanks_recalc'], 2, 0);
	print_description_row($vbphrase['dbtech_thanks_recalc_descr']);
	print_input_row($vbphrase['number_of_users_to_process_per_cycle'], 'perpage', 1000);
	print_submit_row($vbphrase['dbtech_thanks_recalc']);
	
	print_form_header('thanks', 'maintenance');
	construct_hidden_code('action', 'rebuildstatistics');	
	print_table_header($vbphrase['dbtech_thanks_rebuild_statistics'], 2, 0);
	print_description_row($vbphrase['dbtech_thanks_rebuild_statistics_descr']);
	print_input_row($vbphrase['number_of_users_to_process_per_cycle'], 'perpage', 1000);
	print_submit_row($vbphrase['dbtech_thanks_rebuild_statistics']);
	
	($hook = vBulletinHook::fetch_hook('dbtech_thanks_maintenance')) ? eval($hook) : false;
	
	print_cp_footer();
}

// #############################################################################
if ($_REQUEST['action'] == 'cleanup')
{
	print_cp_header($vbphrase['maintenance']);
	
	$vbulletin->input->clean_array_gpc('r', array(
		'perpage' => TYPE_UINT,
		'startat' => TYPE_UINT
	));
	
	if (empty($vbulletin->GPC['perpage']))
	{
		$vbulletin->GPC['perpage'] = 1000;
	}
	
	echo '<p>' . $vbphrase['dbtech_thanks_cleaning_up_posts'] . '</p>';
	
	$entries = $db->query_read_slave("
		SELECT entry.*
		FROM " . TABLE_PREFIX . "dbtech_thanks_entry AS entry
		LEFT JOIN " . TABLE_PREFIX . "post AS post ON(post.postid = entry.contentid)
		WHERE entry.entryid >= " . $vbulletin->GPC['startat'] . "
			AND contenttype = 'post'
			AND post.postid IS NULL
		ORDER BY entry.entryid
		LIMIT " . $vbulletin->GPC['perpage']
	);
	
	$finishat = $vbulletin->GPC['startat'];
	
	while ($entry = $db->fetch_array($entries))
	{
		echo construct_phrase($vbphrase['processing_x'], $entry['entryid']) . "<br />\n";
		vbflush();
		
		// init data manager
		$dm =& THANKS::datamanager_init('Entry', $vbulletin, ERRTYPE_CP);
			$dm->set_existing($entry);
		$dm->delete();
	
		$finishat = ($entry['entryid'] > $finishat ? $entry['entryid'] : $finishat);
	}
	
	$finishat++;
	
	if ($checkmore = $db->query_first_slave("
		SELECT entryid FROM " . TABLE_PREFIX . "dbtech_thanks_entry AS entry
		LEFT JOIN " . TABLE_PREFIX . "post AS post ON(post.postid = entry.contentid)
		WHERE entryid >= $finishat
			AND contenttype = 'post'
			AND post.postid IS NULL
		LIMIT 1
	"))
	{
		print_cp_redirect("thanks.php?" . $vbulletin->session->vars['sessionurl'] . "do=maintenance&action=cleanup&startat=$finishat&pp=" . $vbulletin->GPC['perpage']);
		echo "<p><a href=\"thanks.php?" . $vbulletin->session->vars['sessionurl'] . "do=maintenance&amp;action=cleanup&amp;startat=$finishat&amp;pp=" . $vbulletin->GPC['perpage'] . "\">" . $vbphrase['click_here_to_continue_processing'] . "</a></p>";
	}
	else
	{
		
		define('CP_REDIRECT', 'thanks.php?do=maintenance');
		print_stop_message('dbtech_thanks_cleanup_succeeded');
	}
	
	print_cp_footer();
}

// #############################################################################
if ($_REQUEST['action'] == 'recalc')
{
	print_cp_header($vbphrase['maintenance']);
	
	$vbulletin->input->clean_array_gpc('r', array(
		'perpage' => TYPE_UINT,
		'startat' => TYPE_UINT
	));
	
	if (empty($vbulletin->GPC['perpage']))
	{
		$vbulletin->GPC['perpage'] = 1000;
	}
	
	echo '<p>' . $vbphrase['dbtech_thanks_recalculating'] . '</p>';
	
	$users = $db->query_read_slave("
		SELECT userid
		FROM " . TABLE_PREFIX . "user AS user
		WHERE userid >= " . $vbulletin->GPC['startat'] . "
		ORDER BY userid
		LIMIT " . $vbulletin->GPC['perpage']
	);
	
	$finishat = $vbulletin->GPC['startat'];
	
	while ($user = $db->fetch_array($users))
	{
		// Shorthand
		$userid = intval($user['userid']);
		
		echo construct_phrase($vbphrase['processing_x'], $userid) . "<br />\n";
		vbflush();
		
		$user['dbtech_thanks_points'] = 0;
		
		$given_q = $db->query_read_slave("
			SELECT COUNT(*) as value, varname 
			FROM `" . TABLE_PREFIX . "dbtech_thanks_entry`
			WHERE userid = $user[userid]
			GROUP BY varname		
		");
		$received_q = $db->query_read_slave("
			SELECT COUNT(*) as value, varname 
			FROM `" . TABLE_PREFIX . "dbtech_thanks_entry`
			WHERE receiveduserid = $user[userid]
			GROUP BY varname		
		");
		
		// All given entries
		while ($given_r = $db->fetch_array($given_q))
		{
			// Store given
			$user[$given_r['varname'] . '_given'] = $given_r['value'];
			$user['dbtech_thanks_points'] += $given_r['value'];
		}
		$db->free_result($given_q);
		unset($given_r);
		
		// All received entries
		while ($received_r = $db->fetch_array($received_q))
		{
			// Store received
			$user[$received_r['varname'] . '_received'] = $received_r['value'];
			$user['dbtech_thanks_points'] += $received_r['value'];
		}
		$db->free_result($received_q);
		unset($received_r);
			
		$db->query_write("
			UPDATE " . TABLE_PREFIX . "user
			SET	dbtech_thanks_points = '" . intval($user['dbtech_thanks_points']) . "'
			WHERE userid = '$user[userid]'
		");
		
		if (!empty(THANKS::$cache['button']))
		{
			// Begin columns
			$SQL = array();
			foreach (THANKS::$cache['button'] as $button)
			{
				$SQL[] = $button['varname'] . '_given = ' . intval($user[$button['varname'] . '_given']);
				$SQL[] = $button['varname'] . '_received = ' . intval($user[$button['varname'] . '_received']);
			}
			
			$db->query_write("
				UPDATE " . TABLE_PREFIX . "dbtech_thanks_statistics
				SET	
					" . implode(', ', $SQL) . "
				WHERE userid = '$user[userid]'
			");
		}
		
		$finishat = ($userid > $finishat ? $userid : $finishat);
	}
	
	$finishat++;
	
	if ($checkmore = $db->query_first_slave("SELECT userid FROM " . TABLE_PREFIX . "user WHERE userid >= $finishat LIMIT 1"))
	{
		print_cp_redirect("thanks.php?" . $vbulletin->session->vars['sessionurl'] . "do=maintenance&action=recalc&startat=$finishat&pp=" . $vbulletin->GPC['perpage']);
		echo "<p><a href=\"thanks.php?" . $vbulletin->session->vars['sessionurl'] . "do=maintenance&amp;action=recalc&amp;startat=$finishat&amp;pp=" . $vbulletin->GPC['perpage'] . "\">" . $vbphrase['click_here_to_continue_processing'] . "</a></p>";
	}
	else
	{	
		define('CP_REDIRECT', 'thanks.php?do=maintenance');
		print_stop_message('dbtech_thanks_recalc_successful');
	}
	
	print_cp_footer();
}

// #############################################################################
if ($_REQUEST['action'] == 'rebuildstatistics')
{
	print_cp_header($vbphrase['maintenance']);
	
	$vbulletin->input->clean_array_gpc('r', array(
		'perpage' => TYPE_UINT,
		'startat' => TYPE_UINT
	));
	
	if (empty($vbulletin->GPC['perpage']))
	{
		$vbulletin->GPC['perpage'] = 1000;
	}
	
	echo '<p>' . $vbphrase['dbtech_thanks_recalculating'] . '</p>';	
	
	$users = $db->query_read_slave("
		SELECT *
		FROM " . TABLE_PREFIX . "user AS user
		WHERE userid >= " . $vbulletin->GPC['startat'] . "
		ORDER BY userid
		LIMIT " . $vbulletin->GPC['perpage']
	);
	
	$finishat = $vbulletin->GPC['startat'];
	
	while ($user = $db->fetch_array($users))
	{
		// Shorthand
		$userid = intval($user['userid']);
		
		echo construct_phrase($vbphrase['processing_x'], $userid) . "<br />\n";
		vbflush();
		
		// Insert the record
		$db->query_write("INSERT IGNORE INTO " . TABLE_PREFIX . "dbtech_thanks_statistics (userid) VALUES ($userid)");
		
		$data = array();
		$entries = $db->query_read_slave("
			SELECT *
			FROM `" . TABLE_PREFIX . "dbtech_thanks_entry`
			WHERE userid = $userid
				OR receiveduserid = $userid
		");
		while ($entry = $db->fetch_array($entries))
		{
			// Set the array
			$data[$entry['varname'] . ($entry['receiveduserid'] == $userid ? '_received' : '_given')]++;
		}
		unset($entry);
		$db->free_result($entries);
		
		if (!empty($data))
		{
			$SQL = array();
			foreach ($data as $key => $val)
			{
				$SQL[] = "$key = $val";
			}
			
			// Update the record
			$db->query_write("
				UPDATE " . TABLE_PREFIX . "dbtech_thanks_statistics
				SET " . implode(',', $SQL) . "
				WHERE userid = $userid
			");
		}
		$finishat = ($userid > $finishat ? $userid : $finishat);
	}
	$finishat++;
	
	if ($checkmore = $db->query_first_slave("SELECT userid FROM " . TABLE_PREFIX . "user WHERE userid >= $finishat LIMIT 1"))
	{
		print_cp_redirect("thanks.php?" . $vbulletin->session->vars['sessionurl'] . "do=maintenance&action=rebuildstatistics&startat=$finishat&pp=" . $vbulletin->GPC['perpage']);
		echo "<p><a href=\"thanks.php?" . $vbulletin->session->vars['sessionurl'] . "do=maintenance&amp;action=rebuildstatistics&amp;startat=$finishat&amp;pp=" . $vbulletin->GPC['perpage'] . "\">" . $vbphrase['click_here_to_continue_processing'] . "</a></p>";
	}
	else
	{	
		print_cp_message('Statistics Populated!', 'thanks.php?' . $vbulletin->session->vars['sessionurl'] . 'do=maintenance', 1, NULL, false);
	}
	
	print_cp_footer();
}

/*=======================================================================*\
|| ##################################################################### ||
|| # Created: 17:29, Sat Dec 27th 2008                                 # ||
|| # SVN: $RCSfile: vbshout.php,v $ - $Revision: $WCREV$ $
|| ##################################################################### ||
\*=======================================================================*/
?>